/************************************************************************
* Modulo : manta                   Archivo: manta.h                     *
* Fecha creacion : 21/Jan/92                                            *
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
* Declaracion de constantes,macros y tipos comunes a los TADs           *
************************************************************************/

#ifndef manta_h
#define manta_h
 
       /*------------------------------------------------------+
       |                      CONSTANTES                       |
       +------------------------------------------------------*/

#ifndef TRUE
#define TRUE    1
#endif

#ifndef FALSE
#define FALSE   0
#endif
 
 
       /*------------------------------------------------------+
       |    MACROS para BOOL y NAT                             |
       +------------------------------------------------------*/

#define IMP(a,b)     ((!a) || (b)) 
#define EVEN(a)      ((a)%2 == 0)
#define ODD(a)       ((a)%2 != 0)
#define DIVIDES(a,b) (b%a == 0)
#define ISZERO(a)    (a == 0)
#define MAX(a,b)     ((a)>(b)?a:b)
#define MIN(a,b)     ((a)<(b)?a:b)
#define GE(a,b)      ((a)>=(b))
#define LE(a,b)      ((a)<=(b))
#define LT(a,b)      ((a)<(b))
#define GT(a,b)      ((a)>(b))

       /*------------------------------------------------------+
       |                         TIPOS                         |
       +------------------------------------------------------*/

typedef int    BOOL;

typedef void   *ptr;
 
typedef struct smanta_tad{
	int		manta_uso;
} *manta_tad;

       /*------------------------------------------------------+
       |                      MACROS                           |
       +------------------------------------------------------*/

#define uso_obj(obj)  (obj->manta_uso)

#define inc_uso(obj)  (++(obj->manta_uso))

#define dec_uso(obj)  (--(obj->manta_uso))

        /*------------------------------------------------------+
        |   Prototipos de las funciones de NAT y BOOL           |
        +------------------------------------------------------*/

extern 
int  FACT(int n);

extern
int  EXP(int b, int n);

#endif









